<template>
  <v-dialog :value="value" @input="$emit('input')" width="650">
    <v-card class="mx-auto" height="220">
      <v-card-title class="v-container-tittle">AGREGAR UN DOCUMENTO</v-card-title>
      <v-card-text>
        <v-row class="v-container-buttons">
          <v-col class="font-weight-bold" md="2">Documento:</v-col>
          <v-col md="10">
            <input
              type="file"
              label="Solo formato .pdf, .xmls, .doc"
              @change="uploadFile"
            >
          </v-col>
        </v-row>
        <v-row>
          <v-col md="12">
            <h3 class="v-text-incorrect" v-if="disabledValue"> {{this.messageAlert}}</h3>
            <h3 class="v-text-correct" v-else>{{this.messageAlert}}</h3>
          </v-col>
        </v-row>
      </v-card-text>
      <v-card-actions>
        <v-row class="v-container-buttons">
          <v-col md="2"></v-col>
          <v-col>
            <v-btn
              depressed
              color="primary"
              style="padding:15px"
              rounded
              outlined
              @click="$emit('input')"
            >
              Cancelar
            </v-btn>
          </v-col>
          <v-col>
            <v-btn
              depressed
              color="primary"
              style="padding:15px"
              rounded
              :disabled="this.disabledValue"
              @click="postDocument"
            >
              Agregar
            </v-btn>
          </v-col>
        </v-row>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script>
import { mapActions } from 'vuex';

export default {
  props: {
    value: Boolean,
    idAppointmentDetail: Number,
  },
  name: 'AddDocumentDialogPatient',
  data: () => ({
    nameDocument: null,
    document: null,
    disabledValue: true,
    messageAlert: '',
    register: 0,
  }),
  methods: {
    ...mapActions({
      registerDocumentInDetailAppointment: 'specialist/appointments/registerDocumentInDetailAppointment',
    }),
    uploadFile(event) {
      this.document = event.target.files[0];
      console.log('GET FORMAT:', event.target.files[0]);

      if (event.target.files[0].size <= 500000000) {
        this.disabledValue = false;
        this.messageAlert = 'El archivo tiene un tamaño de ' + (event.target.files[0].size / 1048576).toFixed(2) + 'MB';
      } else {
        this.disabledValue = true;
        this.messageAlert = 'El archivo tiene un tamaño de ' + (event.target.files[0].size / 1048576).toFixed(2) + 'MB y el tamaño máximo es de 500MB';
      }
    },
    postDocument() {
      const formData = new FormData();
      formData.append('multipartFile', this.document);
      this.registerDocumentInDetailAppointment({ idAppointment: this.idAppointmentDetail, payload: formData })
        .then((response) => {
          this.$emit('refresh');
        });
      this.$emit('input');
    },
  },
};
</script>

<style scoped>
.v-container-buttons {
  display: flex;
  align-items: center;
}
.v-container-tittle {
  text-align: center;
  display: flex;
}
.v-text-correct {
  color: #1ecd96;
  align-items: center;
}
.v-text-incorrect {
  color: red;
  align-items: center;
  display: flex;
}
</style>
